// This example code is in the public domain.

import processing.serial.*;


Serial myPort;                       // The serial port
int[] serialInArray = new int[3];    // Where we'll put what we receive
int serialCount = 0;                 // A count of how many bytes we receive
int xpos, ypos;		             // Starting position of the ball
boolean firstContact = false;        // Whether we've heard from the microcontroller

int input_1;
int input_2;
int input_3;

float input_1_mapped;

void setup() {
  size(256, 256);  // Stage size
  noStroke();      // No border on the next thing drawn

  // Set the starting position of the ball (middle of the stage)
  xpos = width/2;
  ypos = height/2;


  ellipseMode(CENTER);

  // Print a list of the serial ports, for debugging purposes:
  println(Serial.list());

  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);
}

void draw() {
  background(0);



   fill(0, 255, 50);  


  // Draw the shape

  ellipse(width/2, width/2, input_1_mapped, input_1_mapped);



}

void serialEvent(Serial myPort) {
  // read a byte from the serial port:
  int inByte = myPort.read();
  // if this is the first byte received, and it's an A,
  // clear the serial buffer and note that you've
  // had first contact from the microcontroller. 
  // Otherwise, add the incoming byte to the array:
  if (firstContact == false) {
    if (inByte == 'A') { 
      myPort.clear();          // clear the serial port buffer
      firstContact = true;     // you've had first contact from the microcontroller
      myPort.write('A');       // ask for more
    } 
  } 
  else {
    // Add the latest byte from the serial port to array:
    serialInArray[serialCount] = inByte;
    serialCount++;

    // If we have 3 bytes:
    if (serialCount > 2 ) {
      input_1 = serialInArray[0];
      input_2 = serialInArray[1];
      input_3 = serialInArray[2];

      if(input_1 > 50){
       input_1 = 50; 
      }  

   input_1_mapped = map(input_1, 0, 50, 0, 255);
    input_1_mapped = int(input_1_mapped);
      // print the values (for debugging purposes only):
      println(input_1_mapped  + "\t" + input_2 + "\t" + input_3);

      // Send a capital A to request new sensor readings:
      //myPort.write('A');
  if(input_1_mapped > 60){
      myPort.write('B');
      println("sending B");
  }else


  if(input_1_mapped < 20){
      myPort.write('C');
      println("sending C");

  }else{
    myPort.write('A');   
  }  
      
      // Reset serialCount:
      serialCount = 0;
    }
  }
}
